;---------------------------------------------------------------------------
;
; Marble Craze by Paul Slocum
;
; Main program, bank 1
;
;---------------------------------------------------------------------------

	processor 6502	
	include vcs.h	


	;TODO
	; 
	; Level Intro Text
	;
	; Timer
	;
	; Power ups
	; 	Power up display text
	;   Collision detection
	;	Power up activation
	;
	; Title Screen
	;
	; Wall handling
	;
	;
	;
	;LATER
	;
	; *BUG* Figure out why p2xVel must be offset at start
	; Reduce velocity table?
	;
	; Fall off animation
	;
	; Add friction
	; Jump handling
	;
	; Write C program to generate levels
	;
	; Score
	;
	; 1 Player mode
	;
	


;---------------------------------------------------------------------------
; Constants
;---------------------------------------------------------------------------
KERNAL_DELAY equ 8

;Status bits
FLASH equ 8
NOCONTROL equ 16

; Status
NORMAL equ 0
FALLOFF equ 1 + FLASH + NOCONTROL
RESET equ 2 + FLASH + NOCONTROL
SCREENLOAD equ 3
FINISHED equ 4 + NOCONTROL
STARTUP equ 5 + FLASH + NOCONTROL


;---------------------------------------------------------------------------
; RAM Variables 
;---------------------------------------------------------------------------

playField equ $80 			; 72 bytes (12 lines * 5) + 12 color bytes

;------------------------------------ 8 bytes 
; 16 bit temp (overlaps with pfBuffer)
temp16L equ playField + 72	
temp16H equ temp16L + 1

levelL equ temp16H + 1	; temp level pointer (during game logic)
levelH equ levelL + 1

screenL equ levelH + 1	; temp screen pointer (during game logic)
screenH equ screenL + 1

temp equ screenH + 1	; two more temps (for game logic)
temp2 equ temp + 1

;------
pfBuffer equ playField + 72	
;------------------------------------

pMarble equ pfBuffer + 8; 2 bytes
pMarble2 equ pMarble + 2; 2 bytes
pfColor equ pMarble2 + 2

frame equ pfColor + 1

p1x equ frame + 1
p1y equ p1x + 1
p2x equ p1y + 1
p2y equ p2x + 1

p1xVel equ p2y + 1
p1yVel equ p1xVel + 1
p2xVel equ p1yVel + 1
p2yVel equ p2xVel + 1

pwr1x equ p2yVel + 1
pwr1y equ pwr1x + 1
pwr2x equ pwr1y + 1
pwr2y equ pwr2x + 1

padVal1 equ pwr2y + 1
padVal2 equ padVal1 + 1
padVal3 equ padVal2 + 1
padVal4 equ padVal3 + 1

level equ padVal4 + 1

p1Screen equ level + 1
p2Screen equ p1Screen + 1

p1Status equ p2Screen + 1
p2Status equ p1Status + 1

p1Counter equ p2Status + 1
p2Counter equ p1Counter + 1

beat equ p2Counter + 1
measure equ beat + 1

; 113 bytes total (measure)




DISPLAY equ measure + 1


; These two temp variables are in the stack area,
; and are only used during the kernal where
; the stack is not used.
temp3 equ $FE
temp4 equ $FF


; Status
;--------------
; 0 Normal Play
; 2 Fall off		; animate / disable paddle control
; 3 Reset			; load reset x/y, vel=0, disable paddle control
; 4 Finished		; vel=0, disable paddle control, stop timer
;
; Status -> Kernal Control
;------------------------
; 2 = flash



; Features to implement:  time, score, powerups, flight, music
; Estimated memory usage
; ----------------------------
; time 3 bytes (two times, one time counter)
; powerups 2 bytes (one 8 bit power up tracker for each player)
; score 4 bytes (two BCD bytes each)
;
; flight 2 bytes (use bits in existing variables if necessary)\
; lives 2 bytes (might use bits in status variables)












;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
	org $1000
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------

marbleData2
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0

	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0

	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0

	byte #%00111100
	byte #%01111110
	byte #%01111110
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%01111110
	byte #%01111110
	byte #%00111100

	align 256
marbleData3
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0

	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0

	byte #%00111100
	byte #%01111110
	byte #%01111110
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%11111111
	byte #%01111110
	byte #%01111110
	byte #%00111100		; total = 99 bytes

	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0
	byte 0,0,0,0,0,0,0,0



	align 256

movement
	byte #%01110001, #%01100001, #%01010001, #%01000001, #%00110001, #%00100001, #%00010001, #%00000001
	byte #%11110001, #%11100001, #%11010001, #%11000001, #%10110001, #%10100001, #%10010001

	byte #%01110010, #%01100010, #%01010010, #%01000010, #%00110010, #%00100010, #%00010010, #%00000010
	byte #%11110010, #%11100010, #%11010010, #%11000010, #%10110010, #%10100010, #%10010010

	byte #%01110011, #%01100011, #%01010011, #%01000011, #%00110011, #%00100011, #%00010011, #%00000011
	byte #%11110011, #%11100011, #%11010011, #%11000011, #%10110011, #%10100011, #%10010011

	byte #%01110100, #%01100100, #%01010100, #%01000100, #%00110100, #%00100100, #%00010100, #%00000100
	byte #%11110100, #%11100100, #%11010100, #%11000100, #%10110100, #%10100100, #%10010100

	byte #%01110101, #%01100101, #%01010101, #%01000101, #%00110101, #%00100101, #%00010101, #%00000101
	byte #%11110101, #%11100101, #%11010101, #%11000101, #%10110101, #%10100101, #%10010101

	byte #%01110110, #%01100110, #%01010110, #%01000110, #%00110110, #%00100110, #%00010110, #%00000110
	byte #%11110110, #%11100110, #%11010110, #%11000110, #%10110110, #%10100110, #%10010110

	byte #%01110111, #%01100111, #%01010111, #%01000111, #%00110111, #%00100111, #%00010111, #%00000111
	byte #%11110111, #%11100111, #%11010111, #%11000111, #%10110111, #%10100111, #%10010111

	byte #%01111000, #%01101000, #%01011000, #%01001000, #%00111000, #%00101000, #%00011000, #%00001000
	byte #%11111000, #%11101000, #%11011000, #%11001000, #%10111000, #%10101000, #%10011000

	byte #%01111001, #%01101001, #%01011001, #%01001001, #%00111001, #%00101001, #%00011001, #%00001001
	byte #%11111001, #%11101001, #%11011001, #%11001001, #%10111001, #%10101001, #%10011001

	byte #%01111010, #%01101010, #%01011010, #%01001010, #%00111010, #%00101010, #%00011010, #%00001010
	byte #%11111010, #%11101010, #%11011010, #%11001010, #%10111010, #%10101010, #%10011010

paddleDecode
	byte 0,0,0,0,0,0,1,1,1,1,1,1,1
	byte 2,2,2,2,2,2,3,3,3,3,3,3,3
	byte 4,4,4,4,4,4,5,5,5,5,5,5,5
	byte 5,5,5,5,5,5,6,6,6,6,6,6,6
	byte 6,6,6,6,6,6,7,7,7,7,7,7,7
	byte 7,7,7,7,7,7,8,8,8,8,8,8,8
	byte 8,8,8,8,8,8,8,8,8,8,8,8,8
	byte 9,9,9,9,9,9,9,9,9,9,9,9,9
	byte 10,10,10,10,10,10,10,10,10,10,10,10,10
	byte 11,11,11,11,11,11,11,11,11,11,11,11,11
	byte 12,12,12,12,12,12,12,12,12,12,12,12,12
	byte 13,13,13,13,13,13,14,14,14,14,14,14,14
	byte 15,15,15,15,15,15



;--------------------------------------------------------------------------
; Draw Screen
;--------------------------------------------------------------------------
drawScreen

	;******************* Position P0/P1 for Score ***********************

	sta HMCLR
	; Set horizontal player positions for score
	sta WSYNC
	lda (temp),x
	lda (temp),x
	lda (temp),x
	lda (temp),x
	lda temp
	sta RESP0
	lda (temp),x
	lda (temp),x
	lda temp
	sta RESBL
	nop
	lda temp
	sta RESP1	
	
	lda #%00100000
	sta HMP0
	lda #%00010000
	sta HMBL
	sta WSYNC
	sta HMOVE

	; ***************** Wait for Timer ******************

	ldx #$80
	; Wait for timer
timer
    LDA INTIM
    BNE timer ;Loops until the timer is done - that means we're
                   ;somewhere in the last line of vertical blank.

    STA WSYNC      ;End the current scanline - the last line of VBLANK.
    STA VBLANK     ;End the VBLANK period.  The TIA will display stuff
                   ;starting with the next scanline.  We do have 23 cycles
                   ;of horizontal blank before it displays anything.

	lda #%10010010
	sta GRP0
	
	lda #%00000111
	sta NUSIZ0
	sta NUSIZ1

	lda #0
	sta GRP0
	sta GRP1
	sta COLUP0
	sta COLUP1
	sta CTRLPF
	lda #255
	sta ENABL
	sta WSYNC
	lda #$0F
    STA COLUPF
	
	; ************** Score Draw Loop ********************

    LDY #6      ;We're going to use Y to count lines.
scoreLoop
	lda scoreData1,y
	sta PF1
	lda scoreP0,y
	sta GRP0
	lda scoreData2,y
	sta PF2
	lda scoreP1,y
	sta GRP1
    STA WSYNC      ;Wait for end of scanline
    DEY
    BNE scoreLoop   ;Count scanlines.

	lda #0
	sta PF1
	sta PF2

	; ************** Future Status and Timer (22 lines) ****************

	sta WSYNC

	; For debugging
;	lda #%00001111
;	sta PF2

	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC

	; For debugging
	lda DISPLAY
;	sta PF0
;	sta PF1
	sta PF2

	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC
	sta WSYNC


	; ***************** Position Game Objects *********************

	lda #$54
	sta pfColor
	
	; Set sizes
	lda #32		;2
	sta NUSIZ1	;3
	lda #0
	sta NUSIZ0	;3
	sta PF1		;3
	sta PF2		;3

	; preLoad playfield color buffer
	lda playField+71+6
	sta pfBuffer+7

	lda #6
	sta temp4

	; ***************** Position M0 (Divider Line) *********************
	
	nop
	nop
	nop
	nop
	nop

	sta HMCLR
	sta RESM0
	lda #%00010000
	sta HMM0

	sta WSYNC

	; ***************** Set Up Marble Shape Pointers *******************

	; Set up P0 (Left Player)

	; Make it flash if it's in falloff/startup mode
	lda p1Status
	and #FLASH
	and frame
	beq draw1	

	; Draw it off screen
	lda #>marbleData3
	sta pMarble+1
	
	lda #99
	sta pMarble
	
	jmp noOffset

draw1
	; Draw it normally
	lda #>marbleData2
	sta pMarble+1

	lda p1y
	sta pMarble

	; For vertical values >100 a different page of image data is used
	cmp #100
	bmi noOffset

	sbc #64
	sta pMarble			;3

	lda #>marbleData3
	sta pMarble+1

noOffset

	sta WSYNC

	; Set up P1 (Right Player)
	
	; Make it flash if it's in falloff/startup mode
	lda p2Status
	and #FLASH
	and frame
	beq draw2

	; Draw it off screen
	lda #>marbleData3
	sta pMarble2+1
	
	lda #99
	sta pMarble2
	
	jmp noOffset2

draw2
	; Draw it normally
	lda #>marbleData2
	sta pMarble2+1

	lda p2y
	sta pMarble2

	; For vertical values >100 a different page of image data is used
	cmp #100
	bmi noOffset2
	sbc #64
	sta pMarble2			;3

	lda #>marbleData3
	sta pMarble2+1

noOffset2
	
	sta WSYNC

	; Set player colors to white
	lda #$0F		;2
	sta COLUP0		;3
	sta COLUP1		;3


	;**************** Position P0 (Left Marble) ***************

	lda p1x
	lsr
	tax
	STA WSYNC
	; Uses a lookup table to get the fine and course movement
	lda movement,x
	STA HMP0
	AND #$0F
	TAY

pPos1
	DEY
	BPL pPos1
	STA RESP0


	STA WSYNC
	STA HMOVE

	;**************** Position P1 (Right Marble) ***************

	nop
	nop	

	lda p2x
	clc
	adc #5
	
	lsr
	tax

	; Uses a lookup table to get the fine and course movement
	lda movement,x
	STA HMP1

	ldx #0
	stx HMP0
	stx HMM0

	AND #$0F
	TAY

pPos2
	DEY
	BPL pPos2

	STA RESP1

	; **************** Position M1 (Power Ups) *********************

	STA WSYNC
	STA HMOVE
	

	; Power up flickers between player 1 and 2
	; power up.
	ldx pwr1x
	lda frame
	and #%00000001
	beq powerUp1

	lda pwr2x	
	clc
	adc #77
	tax

powerUp1

	; Uses a lookup table to get the fine and course movement
	lda movement,x
	ldy #$0F


	sta WSYNC
	sta HMCLR

	STA HMM1

	AND #$0F
	TAY
pPos3
	DEY
	BPL pPos3
	STA RESM1


	sta WSYNC
	sta HMOVE

	; The Ball is used to show the center divider in the score
	; area, but M0 is used in the game area.  Turn on M0 here.
	lda #$FF
	sta ENAM0

	;******* Calculate line position of Vertical Paddle bar (Ball) *******

	; temp16L stores the position
	; of the vertical paddle indicator
	ldx padVal1

	lda frame
	and #1
	bne vertPad1

	ldx padVal3
vertPad1

	lda paddleDecode,x

	sta temp3
	lda #14
	sec
	sbc temp3
	bcc padZero

	clc
	adc #1
	jmp notPadZero

padZero 
	lda #1
notPadZero

	sta temp3

	ldx #$0

	cmp #13
	bmi ballOff

	ldx #$FF

ballOff

	stx ENABL

	lda #%00010000
	sta CTRLPF

	sta WSYNC

	; Draw top white line
	lda #$0F
	sta COLUBK
	sta COLUBK
	

	;*********** Position Ball (shows vertical Paddle position) ***********

	; The ball graphics flickers between the left side and right side
	; to indicate both player's vertical paddle positions

	lda frame
	and #1
	beq right

	ldx #4
ballL
	dex
	bne ballL

	lda #%11010000
	sta HMBL	

	nop
	sta RESBL

	jmp endBallPos

right
	ldx #9
ballR
	dex
	bne ballR

	lda #%10110000
	sta HMBL	

	nop
	sta RESBL

endBallPos
	sta WSYNC
	sta HMOVE


	lda #0
	sta COLUBK
	
	lda #$FF
	sta ENAM0

	nop
	nop
	nop
	nop
	nop
	nop
	nop	
	nop
	nop	
	nop

	;***************** General Setup for Screen Drawing *******************




	; Alternate the two kernals every frame
	lda frame
	and #%00000001
	beq gotoScanLoop2

	jmp gotoScanLoop3	




gotoScanLoop2
	
	; Playfield Reference
	;
	; pfBuffer
	; 0 = PF0.1
	; 1 = PF1.1
	; 2 = PF2.1
	; 3 = PF0.2
	; 4 = PF1.2
	; 5 = PF2.2
	; 6 = PFCOLOR1
	; 7 = PFCOLOR2
	;
	;  0  Hblank  22 PF0 28   PF1   38   PF2   48 PF0 56   PF1   66   PF2   76
	;  |----22----||--6--||---10----||---10----||--6--||---10----||---10----||
	;               4---7  7-------0  0-------7  4---7  7-------0  0-------7

	;****************** Start of Kernal A **********************
	
	; ********* Draw Horizontal Paddle Indicator Left *********

	lda pfColor
	sta COLUPF

	; Get paddle value
	ldx padVal2
	lda paddleDecode,x

	ldy #2
hLoopA	
	sta WSYNC
	
	asl
	asl
	tax
	
	; Use array to convert paddle value
	; to playfield data
	lda hPaddleDisplay,x
	sta PF0
	lda hPaddleDisplay+1,x
	sta PF1
	lda hPaddleDisplay+2,x
	sta PF2
	
	ldx #2
hPadA
	dex
	bne hPadA

	; Turn off display
	lda #0
	sta PF0
	sta PF1
	sta PF2
	
	; Get paddle value
	ldx padVal2
	lda paddleDecode,x

	dey
	bne hLoopA

	sta WSYNC

	; ***************** Prepare for Kernal Loop ****************

	; Set starting Paddle counter values
	lda #161
	sta padVal1
	sta padVal2

	; Delay a bit before start of kernal loop
	ldx #6
kBDelay
	dex
	bne kBDelay

	; PreLoad the next right-playfield color
	lda playField+71
	sta pfBuffer+7

	; preload temp2 value (x/2)
	lda #6
	sta temp4


	; number of blocks
	ldx #12			;2 = 18

	; Use Y to track the actual line
	ldy #156		;2 20

scanLoop2

;	lda pfColor	; waste cycles
	txs			; waste cycles

	lda playField-1,x	;4 76

	; 1A) setup
	;---------------------------------------

	sta PF0				;3
	sta pfBuffer		;3
	lda (pMarble),y		;5*
	sta GRP0			;3
	lda playField+11,x	;4
	sta PF1				;3
	lda playField+23,x	;4
	sta PF2				;3

	lda (pMarble2),y		;5*
	sta GRP1			;3

	lda pfBuffer		;3
	asl					;2
	asl					;2
	asl					;2
	asl					;2
	sta PF0				;3 48
	sta pfBuffer+3		;3

	lda playField+35,x	;4
	sta PF1				;3 55
	lda playField+47,x	;4
	sta PF2				;3
;	sta pfBuffer+5		;3
	dey				;2
	lda (pMarble),y		;5*
	
	; 2A) colors
	;---------------------------------------
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3

	ldx temp4
	lda playField+59,x	;4 66 
	sta COLUPF			;3
	sta pfBuffer+6		;3 
	tsx

	lda playField+11,x	;4
	sta PF1				;3
	lda playField+23,x	;4
	sta PF2				;3 34

	lda (pMarble2),y		;4
	sta GRP1			;3
	
;	nop
	
	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda playField+35,x	;4
	sta PF1				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

;	lda pfBuffer+5		;4
	lda playField+47,x	;4
	sta PF2				;3
	sta pfBuffer+5		;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3

	; 3A) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3
	lda pfColor			;3
	sta COLUPF			;3

	lda playField+11,x	;4
	sta PF1				;3
	sta pfBuffer+1		;3

	lda playField+23,x	;4
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3 39
	
;	nop

	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda playField+35,x	;4
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3 68

	lda INPT0			;3
	bmi paddles1		;2 or 3
	sty padVal1			;3
paddles1

	lda pfBuffer		;3
	sta PF0				;3

	sta WSYNC

	; 4A) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	lda pfBuffer+1		;4
	sta PF1				;3

	lda playField+23,x	;4
	sta PF2				;3 29
	sta pfBuffer+2		;3

	lda (pMarble2),y		;4
	sta GRP1			;3
	

	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda playField+35,x	;4
	sta PF1				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2

	lda (pMarble),y		;4*
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3

	; 5A) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3

	lda pfColor			;3
	sta COLUPF			;3

	lda pfBuffer+1		;3
	sta PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3 29

	lda (pMarble2),y		;4
	sta GRP1			;3
	
	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda playField+35,x	;4
	sta PF1				;3
	sta pfBuffer+4

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3
	lda pfBuffer		;3
	sta PF0				;3
	
	lda INPT1			;3
	bmi paddles2		;2 or 3
	sty padVal2			;3
paddles2

	sta WSYNC

	; 6A) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	txs
	ldx pfBuffer+1		;3
	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	dey					;2
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+5		;4
	sta PF2				;3


	lda (pMarble),y		;4*
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3

	; 7A) more setup
	;---------------------------------------

;	lda pfBuffer		;3
;	sta PF0				;3

	lda pfColor			;3
	stx PF1				;3
	sta COLUPF			;3




	; Draw the power up (using missile 1)
	tsx					;2
	txa					;2
	ldx #ENABL			;2
	txs					;2

	cmp temp3
	php
	cmp pwr1y			;2
	php					;3
	tax

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y	;4
	sta GRP1			;3

	lda pfBuffer+3		;3
	sta PF0				;3


	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3
	
	txs
	nop

	lda pfBuffer		;3
	sta WSYNC

	sta PF0				;3
	ldx pfBuffer+1		;3

	; 8A) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	dey					;2
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3


	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3

	; 9A) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3

	lda pfColor			;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	nop					;8
	nop
	nop
	nop
;	lda #0
;	sta ENABL
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3
	lda pfBuffer		;3
	sta PF0				;3
	
	lda INPT0			;3
	bmi paddles3		;2 or 3
	sty padVal1			;3
paddles3

	sta WSYNC


	; 10A) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	stx PF1				;3

	lda #0
	sta ENAM1

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	;nop
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	dey					;2

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3

	; 11A) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3

	lda pfColor			;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	; This gets X out of the stack register,
	; divides it by two and stores it for use
	; with the color shading.
	tsx
	txa
	lsr
	sta temp4

	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3
	lda pfBuffer		;3
	sta PF0				;3

	lda INPT1			;3
	bmi paddles4		;2 or 3
	sty padVal2			;3
paddles4

	sta WSYNC

	; 12A) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	lda pfBuffer+1		;3
	sta PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	; Grab that color pointer
	ldx temp4
	dey					;2
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3

	; 13A) setup for loop
	;---------------------------------------

	lda pfColor			;3
	sta COLUPF			;3

	lda pfBuffer+1		;3
	sta PF1				;3
	;nop

	; Load the next right-playfield color
	lda playField+65,x	;4 66 
	sta pfBuffer+7			;3 

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y
	sta GRP1

	tsx					;2
	dey

	lda pfBuffer+3		;3
	sta PF0				;3
	lda pfBuffer+4		;4
	sta PF1				;3
	lda pfBuffer+5		;3
	sta PF2				;3


    dex					;2
    beq quitScanLoop2   ;2
	jmp scanLoop2		;3 must be 70

	;******************* End Of Kernal A ***********************

	;******************* Kernal Clean Up **********************

quitScanLoop2
	sta WSYNC

	; Draw the white line at the bottom
	lda #$0F
	sta COLUPF
	lda #255
	sta PF0
	sta PF1
	sta PF2

endOfScreen
	
	; One more scanline
	sta WSYNC
	lda #0
	sta PF0
	sta ENABL
	sta ENAM0
	sta PF1
	sta PF2
	sta COLUP0
	sta COLUP1

	; restore stack
	ldx #253
	txs

    jmp rtnDrawScreen

hPaddleDisplay	; 64 bytes
	byte %00010000, %00000000, %00000000, %00000000
	byte %00010000, %00000000, %00000000, %00000000
	byte %00010000, %00000000, %00000000, %00000000
	byte %00010000, %00000000, %00000000, %00000000
	byte %01100000, %00000000, %00000000, %00000000
	byte %10000000, %10000000, %00000000, %00000000
	byte %00000000, %01100000, %00000000, %00000000
	byte %00000000, %00011000, %00000000, %00000000
	byte %00000000, %00000110, %00000000, %00000000
	byte %00000000, %00000001, %00000001, %00000000
	byte %00000000, %00000000, %00000110, %00000000
	byte %00000000, %00000000, %00011000, %00000000
	byte %00000000, %00000000, %01100000, %00000000
	byte %00000000, %00000000, %10000000, %00000000
	byte %00000000, %00000000, %10000000, %00000000
	byte %00000000, %00000000, %10000000, %00000000

	; ***************** Start of Kernal B ******************

gotoScanLoop3


	; ******* Draw horizontal Paddle Indicator Right *******	

	lda pfColor
	sta COLUPF
	
	ldy #2
hLoopB
	sta WSYNC

	; Get paddle value
	ldx padVal4
	lda paddleDecode,x

	ldx #0
	stx PF0
	stx PF1
	stx PF2

	asl
	asl
	
	ldx #2
hPadB
	dex
	bne hPadB

	tax
	lda hPaddleDisplay,x
	sta PF0
	lda hPaddleDisplay+1,x
	sta PF1
	lda hPaddleDisplay+2,x
	sta PF2


	dey
	bne hLoopB

	sta WSYNC

	ldx #0
	stx PF0
	stx PF1
	stx PF2

	ldx #4
kADelay
	dex
	bne kADelay

	; PreLoad the next right-playfield color
	lda playField+71
	sta pfBuffer+7

	; PreLoad the next left-playfield color
	lda playField+59+6;
;	lda #$54
	sta pfBuffer+6



	; Set starting paddle counter values
	lda #161
	sta padVal3
	sta padVal4

	; number of blocks
	ldx #12			;2 = 18

	; Use Y to track the actual line
	ldy #156		;2 20


scanLoop3
	lda pfColor
;	sta COLUPF

	lda playField-1,x	;4 76

	; 1B) setup
	;---------------------------------------

	sta PF0				;3
	sta pfBuffer		;3
	lda (pMarble),y		;5*
	sta GRP0			;3
	lda playField+11,x	;4
	sta PF1				;3
	lda playField+23,x	;4
	sta PF2				;3

	lda (pMarble2),y		;5*
	sta GRP1			;3

	lda pfBuffer		;3
	asl					;2
	asl					;2
	asl					;2
	asl					;2
	sta PF0				;3 48
	sta pfBuffer+3		;3

	lda playField+35,x	;4
	sta PF1				;3 55
	lda playField+47,x	;4
	sta PF2				;3
	sta pfBuffer+5		;3
	dey				;2

	lda (pMarble),y		;4*
	sta GRP0			;3 68


	; 2B) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3

	lda playField+11,x	;4
	sta PF1				;3
	sta pfBuffer+1		;3

	lda playField+23,x	;4
	sta PF2				;3
	sta pfBuffer+2		;3

	lda (pMarble2),y		;4
	sta GRP1			;3 39
	
;	nop
;	nop
;	nop
	dey					;2

	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda playField+35,x	;4
	sta PF1				;3
	sta pfBuffer+4		;3

	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3 68

	lda INPT2			;3
	bmi paddles5		;2 or 3
	sty padVal3			;3
paddles5

	lda pfBuffer		;3
	sta PF0				;3



;	lda (pMarble),y		;5*
;	sta GRP0			;3
	sta WSYNC


	
	; 3B) colors
	;---------------------------------------

	lda pfBuffer+6		;4 66 
	sta COLUPF			;3
;	sta pfBuffer+6		;3 
	nop
	nop

	lda pfBuffer+1		;3
	sta PF1				;3
	lda pfBuffer+2		;3
	sta PF2				;3 34

	lda (pMarble2),y		;4
	sta GRP1			;3
	
	nop
	nop
	nop
	
	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+4		;3
	sta PF1				;3



	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3

	; 4B) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3

	lda pfColor			;3
	sta COLUPF			;3

	lda pfBuffer+1		;3
	sta PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3 29

	lda (pMarble2),y		;4
	sta GRP1			;3

	dey					;2
	nop
	nop
	
	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3
	lda pfBuffer		;3
	sta PF0				;3
	
	lda INPT3			;3
	bmi paddles6		;2 or 3
	sty padVal4			;3
paddles6

	sta WSYNC

	; 5B) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	lda pfBuffer+1		;4
	sta PF1				;3

	lda playField+23,x	;4
	sta PF2				;3 29
	sta pfBuffer+2		;3

	lda (pMarble2),y		;4
	sta GRP1			;3
	
	lda pfBuffer+3		;3
	sta PF0				;3 52

	lda playField+35,x	;4
	sta PF1				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2

	lda (pMarble),y		;4*
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3


	; 6B) more setup
	;---------------------------------------

	lda pfColor			;3
	sta COLUPF			;3

	lda pfBuffer+1		;3
	sta PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	; Draw the power up (using missile 1)
	txa					;2
	ldx #ENABL			;2
	txs					;2
	cmp temp3
	php
	cmp pwr2y			;2
	php					;3
	tax


	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3
	

	lda pfBuffer		;3
	sta PF0				;3
	nop


	; 7B) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	txs
	ldx pfBuffer+1		;3
	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	dey					;2

	nop
	lda temp3	; waste 3 cycles
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3


	lda (pMarble),y		;4*
	sta GRP0			;3


	; 8B) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3

	lda pfColor			;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	nop					;8
	nop
	nop
	nop
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3
	lda pfBuffer		;3
	sta PF0				;3
	
	lda INPT2			;3
	bmi paddles7		;2 or 3
	sty padVal3			;3
paddles7

	sta WSYNC



	; 9B) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	dey					;2
	nop
	nop
	nop
	lda #0				;2
	sta ENAM1			;3
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+4		;3
	sta PF1				;3


	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3


	; 10B) paddles
	;---------------------------------------

	lda pfBuffer		;3
	sta PF0				;3

	lda pfColor			;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	lda temp3  ; waste 3 cycles
	nop
	nop
	nop
	dey					;2

	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3
	lda pfBuffer		;3
	sta PF0				;3
	
	lda INPT3			;3
	bmi paddles8		;2 or 3
	sty padVal4			;3
paddles8

	sta WSYNC


	; 11B) colors
	;---------------------------------------

	lda pfBuffer+6		;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	lda temp3	; waste 3 cycles
	nop
	nop
	nop
	nop
	dey					;2
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+7		;3
	sta COLUPF			;3

	lda pfBuffer+4		;3
	sta PF1				;3


	lda pfBuffer+5		;4
	sta PF2				;3

	lda (pMarble),y		;4*
	sta GRP0			;3

	lda pfBuffer		;3
	sta PF0				;3


	; 12B) nothing
	;---------------------------------------

	lda pfColor			;3
	sta COLUPF			;3

	stx PF1				;3

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y		;4
	sta GRP1			;3

	; This gets X out of the stack register,
	; divides it by two and stores it for use
	; with the color shading.
	tsx
	txa
	lsr
	nop
	tax
	lda playField+59,x	;4 66 
	sta pfBuffer+6
	
	lda pfBuffer+3		;3
	sta PF0				;3

	lda pfBuffer+4		;3
	sta PF1				;3

	lda pfBuffer+5		;4
	sta PF2				;3

	dey					;2
	lda (pMarble),y		;4*
	sta GRP0			;3

	nop

	lda pfBuffer		;3
	sta PF0				;3

	; 13B) setup for loop
	;---------------------------------------


	lda pfBuffer+1		;3
	sta PF1				;3

	; Load the next right-playfield color
	lda playField+65,x	;4 66 
	sta pfBuffer+7			;3 
	tsx

	lda pfBuffer+2		;3
	sta PF2				;3

	lda (pMarble2),y
	sta GRP1

	nop
	dey

	lda pfBuffer+3		;3
	sta PF0				;3
	lda pfBuffer+4		;4
	sta PF1				;3
	lda pfBuffer+5		;3
	sta PF2				;3


    dex					;2
    beq quitScanLoop3   ;2
	jmp scanLoop3		;3 must be 70

quitScanLoop3
	sta WSYNC

	lda #$0F
	sta COLUPF
	lda #255
	sta PF0
	sta PF1
	sta PF2
	
	jmp endOfScreen

	; ******************* End of Kernal B ******************



			
;---------------------------------------------------------------------------
; Start of Program
;---------------------------------------------------------------------------
; Clear memory, locate character graphics positions and such,
; initialize key memory values, start GameLoop.
;-------------------------------------------------------------
Start
	sei  	
	 cld  		
	ldx #$FF
	txs  		
	lda #0
clear   
	sta 0,x
	dex
	bne clear	


;---------------------------------------------------------------------------
; Initialize variables
;---------------------------------------------------------------------------

	; Set initialization flag.
	; This stays set until the first frame is drawn.
	lda #$0f	;set text color to white
	sta COLUP0
	sta COLUP1	

	lda #255
	sta padVal1
	sta padVal2
	sta padVal3
	sta padVal4

	lda #70
	sta p2x
	sta p1x

	lda #117
	sta p2y
	sta p1y
	
	lda #128
	sta p1xVel
	sta p1yVel
	sta p2xVel
	sta p2yVel

	lda #120
	sta p2xVel

	lda #RESET
	sta p1Status
	sta p2Status

	lda #100
	sta p1Counter
	sta p2Counter

	

;--------------------------------------------------------------------------
; GameLoop
;--------------------------------------------------------------------------
GameLoop
	inc frame	

	jsr VSync 	;start vertical retrace

	jmp VBlank    	; spare time during screen blank
					; uses jmp to avoid extra stack usage
VBlankReturn

	jmp drawScreen	; draw one screen
rtnDrawScreen

	jsr overscan	; do overscan

	jmp GameLoop    ;back to top



;--------------------------------------------------------------------------
; VSync
;--------------------------------------------------------------------------
VSync
	lda #2		;bit 1 needs to be 1 to start retrace
	sta VSYNC	;start retrace
	sta WSYNC 	;wait a few lines
	sta WSYNC 
	lda #44		;prepare timer to exit blank period (44)
	sta TIM64T	;turn it on
	sta WSYNC 	;wait one more
	sta VSYNC 	;done with retrace, write 0 to bit 1

	rts ; VSync



;--------------------------------------------------------------------------
; VBlank
;--------------------------------------------------------------------------
; Handle user input and display setup during the VBLANK period
;--------------------------------------------------------------------------
VBlank

	; ---------------------------------
	; Reset game with Reset Switch

	lda SWCHB
	and #1
	bne noGameReset

	jmp Start

noGameReset


	;-------------------------------------
	; Invert vertical paddle values (1&3)
	lda frame
	and #1
	beq invPad3

	lda #161
	sbc padVal1
	sta padVal1
	jmp quitInv

invPad3
	lda #161
	sbc padVal3
	sta padVal3

quitInv
	
	


	jmp callVBlank2 ; call VBlank routines in bank 2
VBlank2Return

	jmp VBlankReturn ; use jmps to avoid extra stack usage	








;--------------------------------------------------------------------------
; Overscan
;--------------------------------------------------------------------------
overscan

	sta WSYNC	
	lda #33		; Use the timer to make sure overscan takes (34)
	sta TIM64T	; 30 scan lines.  29 scan lines * 76 = 2204 / 64 = 34.4

endOS	
	lda INTIM	; We finished, but wait for timer
	bne endOS	; by looping till zero
	
	sta WSYNC	; End last scanline

	lda #$82
	sta VBLANK

	rts	; overscan













timeData1
scoreP1
scoreP0
	byte #%00000000
	byte #%00000000
	byte #%10000010
	byte #%00000000
	byte #%00000000
	byte #%10010000
	byte #%00000000
	byte #%00000000

scoreData1
	byte #%00000000
	byte #%10110010
	byte #%10110010
	byte #%10110010
	byte #%10110110
	byte #%10110110
	byte #%10110110
	byte #%10110110

scoreData2
	byte #%00000000
	byte #%00010011
	byte #%00010011
	byte #%00010011
	byte #%00010011
	byte #%00010001
	byte #%00011011
	byte #%00011011













	
;	include mtitle.h

;	include songplay.h



;--------------------------------------------------------------------------
; Call VBlank2
;--------------------------------------------------------------------------
; Bankswitching code to call VBlank2 in bank 2
; and then switch back to bank 1.
;--------------------------------------------------------------------------

	org $1FE0

callVBlank2
	ldx $1FF9	; (switch to bank 2)	
	nop         ; 1FE3 jsr beat box
	nop         ; .
	nop         ; .
	nop         ; 1FE6 lda $1FF8  (Switch back to bank 1)        
	nop         ; .
	nop         ; .
	jmp VBlank2Return ; use jumps to avoid extra stack usage


;---------------------------------------------------------------------------
; Program Startup Vector
;---------------------------------------------------------------------------
	org $1FF3  	; The cart may start in bank 2, then a bankswitch
				; will occur and land here...

	jmp Start   ; Start program

	org $1FFC	; Program startup vector
	.word Start
	.word Start

	include marbank2.asm
